<template>
  <div class="app-container">

    <!--<div class="operator-container"> -->
    <div class="filter-container">
      <el-select v-model="listQuery.type"  class="filter-item" placeholder="请选择服务分类">
        <el-option label="单次" :value="1" />
        <el-option label="品类" :value="2" />
        <el-option label="周期" :value="3" />
        <el-option label="保姆钟点工" :value="4" />
        <el-option label="收纳" :value="5" />
        <el-option label="其他" :value="6" />
      </el-select>
      <el-input type="number" clearable class="filter-item" style="width: 170px;"  v-model="listQuery.duration"   placeholder="请输入时长" /> 
      <el-button v-permission="['GET /admin/serviceTimeRange/list']" class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button v-permission="['POST /admin/serviceTimeRange/create']" class="filter-item" type="primary" icon="el-icon-edit" @click="handleCreate">添加</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column align="center" label="服务分类" prop="type">
        <template slot-scope="scope">
          <el-tag :type="scope.row.type==1?'success':scope.row.type==2?'info':'danger'">{{scope.row.type|typeFilter}}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="服务时长" prop="duration"/>

      <el-table-column align="center" label="时间范围" prop="startTime">
        <template slot-scope="scope">
          <el-tag>{{scope.row.startTime}}-{{scope.row.endTime}}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="状态" prop="deleted">
        <template slot-scope="scope">
          <span v-if="scope.row.deleted == true">已停用</span>
          <span v-else>正常</span>
        </template>
      </el-table-column>

      <el-table-column align="center" label="操作" min-width="100" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/serviceTimeRange/update']" type="primary" size="mini" @click="handleUpdate(scope.row)">编辑</el-button>
          <!-- <el-button v-permission="['POST /admin/city/delete']" type="danger" size="mini" @click="handleDelete(scope.row)">删除</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="100px" style="width: 500px; margin-left:50px;">
        <el-form-item label="服务分类" prop="type">
          <el-select v-model="dataForm.type" placeholder="请选择服务分类">
            <el-option label="单次" :value="1" />
            <el-option label="品类" :value="2" />
            <el-option label="周期" :value="3" />
            <el-option label="保姆钟点工" :value="4" />
            <el-option label="收纳" :value="5" />
            <el-option label="其他" :value="6" />
          </el-select>
        </el-form-item>
          <el-form-item label="服务时长" prop="duration">
          <el-input v-model="dataForm.duration" type="number" :maxlength="1" placeholder="请输入服务时长" />
        </el-form-item>
        <el-form-item label="开始时间" prop="startTime">
          <el-input v-model="dataForm.startTime" placeholder="请输入开始时间 格式08:00" :maxlength="5"/>
        </el-form-item>
        <el-form-item label="结束时间" prop="endTime">
          <el-input v-model="dataForm.endTime" placeholder="请输入结束时间 格式08:00" :maxlength="5" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus=='create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog> 

  </div>
</template>


<script>
import {
  listRange,
  deleteRange,
  updateRange,
  createRange,
} from "@/api/serviceTimeRange";
import BackToTop from "@/components/BackToTop";
import Pagination from "@/components/Pagination"; // Secondary package based on el-pagination
import _ from "lodash";

export default {
  name: "Topic",
  components: { BackToTop, Pagination },
  filters: {
    typeFilter(type) {
      if (type == 1) return "保洁";
      if (type == 2) return "品类";
      if (type == 3) return "周期";
      if (type == 4) return "保姆钟点工";
      if (type == 5) return "收纳";
      if (type == 6) return "其他";
    },
  },
  data() {
      const timeValidate = (rule, value, callback) => {
      if (
        this.refereeForm.mobile == null ||
        this.refereeForm.mobile.length < 10
      ) {
        callback(new Error("请输入正确联系方式"));
      } else {
        callback();
      }
    };
    return {
      list: [],
      total: 0,
      listLoading: true,
      listQuery: {
        type: "",
        page: 1,
        limit: 20,
        sort: "create_time",
        order: "desc",
        duration:''
      },
      dataForm: {
        id: undefined,
        name: "",
        remark: undefined,
      },
      dialogFormVisible: false,
      dialogStatus: "",
      textMap: {
        update: "编辑",
        create: "创建",
      },
      rules: {
        type: [{ required: true, message: "服务类型不能为空", trigger: "blur" }],
        duration: [{ required: true, message: "服务时长不能为空", trigger: "blur" }],
        startTime: [{ required: true, message: "开始时间不能为空", trigger: "blur" }],
        endTime: [{ required: true, message: "结束时间不能为空", trigger: "blur" }],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    getList() {
      this.listLoading = true;
      listRange(this.listQuery)
        .then((response) => {
          this.list = response.data.data.list;
          this.total = response.data.data.total;
          this.listLoading = false;
        })
        .catch(() => {
          this.list = [];
          this.total = 0;
          this.listLoading = false;
        });
    },
    handleFilter() {
      this.listQuery.page = 1;
      this.getList();
    },
    handleCreate() {
      this.resetForm();
      this.dialogStatus = "create";
      this.dialogFormVisible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },
    resetForm() {
      this.dataForm = {
        id: undefined,
        name: "",
        remark: undefined,
      };
    },
    createData() {
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          createRange(this.dataForm)
            .then((response) => {
              this.list.unshift(response.data.data);
              this.dialogFormVisible = false;
              this.$notify.success({
                title: "成功",
                message: "创建成功",
              });
            })
            .catch((response) => {
              this.$notify.error({
                title: "失败",
                message: response.data.errmsg,
              });
            });
        }
      });
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row);
      this.dialogStatus = "update";
      this.dialogFormVisible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },
    updateData() {
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          updateRange(this.dataForm)
            .then(() => {
              for (const v of this.list) {
                if (v.id === this.dataForm.id) {
                  const index = this.list.indexOf(v);
                  this.list.splice(index, 1, this.dataForm);
                  break;
                }
              }
              this.dialogFormVisible = false;
              this.$notify.success({
                title: "成功",
                message: "更新成功",
              });
            })
            .catch((response) => {
              this.$notify.error({
                title: "失败",
                message: response.data.errmsg,
              });
            });
        }
      });
    },
    handleDelete(row) {
      deleteRange(row)
        .then((response) => {
          this.$notify.success({
            title: "成功",
            message: "停用城市成功",
          });
          const index = this.list.indexOf(row);
          this.list.splice(index, 1);
        })
        .catch((response) => {
          this.$notify.error({
            title: "失败",
            message: response.data.errmsg,
          });
        });
    },
  },
};
</script>



<style>
.el-table th.gutter {
  display: table-cell !important;
}
.el-dialog {
  width: 800px;
}
</style>